#include "escapi.bi"
Const SCR_W = 640
Const SCR_H = 480


sub RGB2BW(des as ulong ptr,src as ulong ptr,nPixels as integer)
  dim as integer value
  for i as integer=0 to nPixels-1
    Value =(src[i] and &H0000FF)
    Value+=(src[i] and &H00FF00) shr  8
    Value+=(src[i] and &HFF0000) shr 16
    Value\=3
    des[i]=Value
  next
end sub

var nDevices=setupESCAPI()
If nDevices<1 Then
  Print "No active capture device found!"
  Beep : Sleep : End 1
end If

ScreenRes SCR_W,SCR_H,32

var pImage = ImageCreate(SCR_W,SCR_H)
dim As ulong ptr pixels
imageinfo pImage,,,,,pixels

Dim As SimpleCapParams Params
With Params
  .mWidth     = SCR_W
  .mHeight    = SCR_H
  .mTargetBuf = pixels
End With

WindowTitle "initCapture() = " & initCapture(0, @Params)

'
' main
'
Dim As Integer i,v,vy,vx,dx,dy
While inkey()<>chr(27)
  'capture an image
  doCapture(0)
  While isCaptureDone(0)<>1:Sleep(10):Wend
   
  RGB2BW(Params.mTargetBuf,Params.mTargetBuf,SCR_W*SCR_H)
  dim as integer x,y
  for i=0 to SCR_W*SCR_H-(SCR_W+1)
    v  = Params.mTargetBuf[i]
    vy = Params.mTargetBuf[i+SCR_W]
    vx = Params.mTargetBuf[i+1]
    dy = abs(vy-v):dy shl=1
    dx = abs(vx-v):dx shl=1
    If dy>dx Then
      Params.mTargetBuf[i] = (dy Shl 8) 'shade of red
    Else
      Params.mTargetBuf[i]=(dx Shl 16)  'shade of green
    End If
  next
  Put (0,0), pImage,Pset
Wend

