
#include "escapi.bi"
Const SCR_W = 640
Const SCR_H = 480

Dim As long nDevices=setupESCAPI()
If nDevices<1 Then
  Print "No active capture device found!"
  Beep:Sleep:End
end If

ScreenRes SCR_W,SCR_H,32


var pImage = ImageCreate(SCR_W,SCR_H)
dim as ulong ptr pixels
imageinfo pImage,,,,,pixels

'gray images
Dim Shared As Ulong image1(SCR_W,SCR_H)
Dim Shared As Ulong image2(SCR_W,SCR_H)
Dim Shared As Ulong image3(SCR_W,SCR_H)

Dim As SimpleCapParams Params
With Params
  .mWidth     = SCR_W
  .mHeight    = SCR_H
  .mTargetBuf = pixels
End With

WindowTitle "MonoDifference" & Str(initCapture(nDevices-1, @Params))

Dim As long r,g,b,v



'capture FIRST image
doCapture(nDevices-1)
While isCaptureDone(nDevices-1)<>1:Sleep(10):Wend
      
'copy to image1()
Dim As integer i=0
For y As integer = 0 To SCR_H-1
  For x As integer = 0 To SCR_W-1
    v = Params.mTargetBuf[i]
    r = v Shr 16 And 255
    g = v Shr  8 And 255
    b = v And 255
    image1(x,y) = (r + g + b)/3
    i += 1
  Next
Next
  
While inkey()<>chr(27)
  'capture NEXT image
  doCapture(nDevices-1)
  While isCaptureDone(nDevices-1)<>1:Sleep(10):Wend
      
  'copy to ANOTHER image2()
  i=0
  For y As integer = 0 To SCR_H-1
    For x As integer = 0 To SCR_W-1
      v = Params.mTargetBuf[i]
      r = v Shr 16 And 255
      g = v Shr  8 And 255
      b = v And 255
      image2(x,y) = (r + g + b)/3
      i = i + 1
    Next
  Next

  'get directions
  Dim As long v,horz,vert 
  For col As integer =1 To SCR_W-2
    For row As integer = 1 To SCR_H-2
      image3(col,row) = 6 ' default background color
      v = Abs(image1(col,row) - image2(col,row)) ' significant change ?

      If v >16 Then 'significant change in pixel value?
        ' mostly vertical or horizontal motion?
        vert = Abs(image1(col,row - 1) - image1(col,row + 1)) 
        horz = Abs(image1(col - 1,row) - image1(col + 1,row)) 
        If (horz > vert) Then
          If (image1(col,row) > image2(col,row)) Then ' getting darker?
            If (image1(col - 1,row) > image1(col + 1,row)) Then
              image3(col,row) = 2  ' left
            elseIf (image1(col - 1,row) < image1(col + 1,row)) Then
              image3(col,row) = 3  ' right
            End If
          Else
            If (image1(col - 1,row) > image1(col + 1,row)) Then
              image3(col,row) = 3  'right
            elseIf (image1(col - 1,row) < image1(col + 1,row)) Then
              image3(col,row) = 2  ' left
            End If
          End If
        Else
          If (image1(col,row) > image2(col,row)) Then ' getting darker?
            If (image1(col,row - 1) > image1(col,row + 1)) Then
              image3(col,row) = 4  ' up
            elseIf (image1(col,row - 1) < image1(col,row + 1)) Then
              image3(col,row) = 5  ' down
            End If
          Else
            If (image1(col,row - 1) > image1(col,row + 1)) Then
              image3(col,row) = 5  ' down
            elseif (image1(col,row - 1) < image1(col,row + 1)) Then
              image3(col,row) = 4  ' up
            End If
          End If
        End If' end if horz/vert block
      End If' end if significant change block
    Next
  Next

  ' image3 holds color code of direction
  ' copy to display buffer for display purposes
  For row As integer = 0 To SCR_H
    i = row * SCR_W 'pointer  
    For col As integer  = 0 To SCR_W
      dim as ulong c
      select case as const image3(col,row)
      ' red LEFT
      case 2 : c=rgb(255,0,0)
      ' green RIGHT
      case 3 : c=rgb(0,255,0)
      ' blue UP
      case 4 : c=rgb(0,0,255)
      ' yellow DOWN
      case 5 : c=rgb(255,255,0)
      ' black DEFAULT no change color
      'case 6 : r = 0 :g = 0: b = 0
      end select
      'copy color code into display buffer
      Params.mTargetBuf[i] = c
      i+=1
    Next
  Next

  Put (0,0), pImage,Pset
      
  'copy image2 to image1 for next round
  For y As integer = 0 To SCR_H-1
    For x As integer = 0 To SCR_W-1
      image1(x,y)=image2(x,y)
    Next
  Next

Wend


 